Index: /tests/widget/widget.cpp
===================================================================
--- /tests/widget/widget.cpp	(revision 367)
+++ /tests/widget/widget.cpp	(revision 368)
@@ -34,4 +34,5 @@
 #define myDefFlagCut(var,fl,varstr,pos) myDefFlagEx(var,fl,varstr,#fl + pos)
 
+#define PRINT_EXPR(e) qWarning() << #e << e
 
 QDebug operator<<(QDebug dbg, Qt::WindowStates st)
@@ -306,5 +307,5 @@
     };
 
-#if 1
+#if 0
     void paintEvent(QPaintEvent *aE)
     {
@@ -325,5 +326,5 @@
         p.drawText(10, 30, QLatin1String("ABC"));
 #endif
-#if 1
+#if 0
         // simple QClipboard image test
 
@@ -500,9 +501,95 @@
 int main(int argc, char **argv)
 {
-#if 0
+#if 1
     ////////////////////////////////////////////////////////////////////////////
     // Text mode
 
     QCoreApplication app(argc, argv);
+
+#if 0
+    //--------------------------------------------------------------------------
+    // QTextStream test
+
+    QFile file("widget.cpp");
+    file.open(QIODevice::ReadOnly);
+    QTextStream text(&file);
+    QString str = text.readAll();
+    file.close();
+    qWarning() << "Read" << str.length() << "chars from widget.cpp";
+#endif
+
+#if 0
+    //--------------------------------------------------------------------------
+    // absolute/relative path test
+    qWarning() << "1" << QDir(QLatin1String("C:\\OS2")).absoluteFilePath(QLatin1String("../aaa"));
+    qWarning() << "1" << QDir(QLatin1String("C:\\OS2")).absoluteFilePath(QLatin1String("aaa"));
+    qWarning() << "1" << QDir(QLatin1String("C:\\OS2")).absoluteFilePath(QLatin1String("/aaa"));
+    qWarning() << "1" << QDir(QLatin1String("C:\\OS2")).absoluteFilePath(QLatin1String("\\aaa"));
+    qWarning() << "1" << QDir(QLatin1String("C:\\OS2")).absoluteFilePath(QLatin1String("D:\\aaa"));
+    qWarning() << "1" << QDir(QLatin1String("C:\\OS2")).absoluteFilePath(QLatin1String("D:aaa"));
+
+    qWarning() << "2" << QDir(QLatin1String(".")).absoluteFilePath(QLatin1String("../aaa"));
+    qWarning() << "2" << QDir(QLatin1String(".")).absoluteFilePath(QLatin1String("aaa"));
+    qWarning() << "2" << QDir(QLatin1String(".")).absoluteFilePath(QLatin1String("/aaa"));
+    qWarning() << "2" << QDir(QLatin1String(".")).absoluteFilePath(QLatin1String("\\aaa"));
+    qWarning() << "2" << QDir(QLatin1String(".")).absoluteFilePath(QLatin1String("D:\\aaa"));
+    qWarning() << "2" << QDir(QLatin1String(".")).absoluteFilePath(QLatin1String("D:aaa"));
+
+    qWarning() << "3" << QDir(QLatin1String("D:bbb")).absoluteFilePath(QLatin1String("../aaa"));
+    qWarning() << "3" << QDir(QLatin1String("D:bbb")).absoluteFilePath(QLatin1String("aaa"));
+    qWarning() << "3" << QDir(QLatin1String("D:bbb")).absoluteFilePath(QLatin1String("/aaa"));
+    qWarning() << "3" << QDir(QLatin1String("D:bbb")).absoluteFilePath(QLatin1String("\\aaa"));
+    qWarning() << "3" << QDir(QLatin1String("D:bbb")).absoluteFilePath(QLatin1String("D:\\aaa"));
+    qWarning() << "3" << QDir(QLatin1String("D:bbb")).absoluteFilePath(QLatin1String("D:aaa"));
+
+    qWarning() << "4" << QDir(QLatin1String("E:bbb")).absoluteFilePath(QLatin1String("D:aaa"));
+    qWarning() << "4" << QDir(QLatin1String("E:bbb")).absoluteFilePath(QLatin1String("bbb"));
+    qWarning() << "4" << QDir(QLatin1String("C:bbb")).absoluteFilePath(QLatin1String("bbb"));
+#endif
+
+#if 1
+    //--------------------------------------------------------------------------
+    // QDir::mkdir/mkpath test
+    PRINT_EXPR(QDir().mkdir("some_dir"));
+    PRINT_EXPR(QFile::exists("some_dir"));
+    PRINT_EXPR(QDir().rmdir("some_dir"));
+
+    PRINT_EXPR(QDir().mkdir("some_dir/subdir"));
+    PRINT_EXPR(QFile::exists("some_dir/subdir"));
+    PRINT_EXPR(QDir().rmdir("some_dir/subdir"));
+
+    PRINT_EXPR(QDir().mkpath("some_dir/subdir"));
+    PRINT_EXPR(QFile::exists("some_dir/subdir"));
+    PRINT_EXPR(QDir().rmpath("some_dir/subdir"));
+
+    PRINT_EXPR(QDir("C:/").mkpath("some_dir/subdir"));
+    PRINT_EXPR(QFile::exists("C:/some_dir/subdir"));
+    PRINT_EXPR(QDir("C:/").rmpath("some_dir/subdir"));
+
+    PRINT_EXPR(QDir("C:/").mkdir("/aaa"));
+    PRINT_EXPR(QFile::exists("C:/aaa"));
+    PRINT_EXPR(QDir("C:/").rmdir("/aaa"));
+#endif
+
+#if 0
+    //--------------------------------------------------------------------------
+    // QLibraryInfo test
+    qWarning() << "QLibraryInfo::buildKey :" << QLibraryInfo::buildKey();
+    qWarning() << "QLibraryInfo::licensedProducts :" << QLibraryInfo::licensedProducts();
+    qWarning() << "QLibraryInfo::licensee :" << QLibraryInfo::licensee();
+    #define PRINT_LOC(L) qWarning() << #L << ":" << QLibraryInfo::location(L)
+    PRINT_LOC(QLibraryInfo::PrefixPath);
+    PRINT_LOC(QLibraryInfo::DocumentationPath);
+    PRINT_LOC(QLibraryInfo::HeadersPath);
+    PRINT_LOC(QLibraryInfo::LibrariesPath);
+    PRINT_LOC(QLibraryInfo::BinariesPath);
+    PRINT_LOC(QLibraryInfo::PluginsPath);
+    PRINT_LOC(QLibraryInfo::DataPath);
+    PRINT_LOC(QLibraryInfo::TranslationsPath);
+    PRINT_LOC(QLibraryInfo::SettingsPath);
+    PRINT_LOC(QLibraryInfo::DemosPath);
+    PRINT_LOC(QLibraryInfo::ExamplesPath);
+    #undef PRINT_LOC
+#endif
 
 #else
@@ -512,5 +599,5 @@
     QApplication app(argc, argv);
 
-#if 1
+#if 0
     //--------------------------------------------------------------------------
     // locale test