Index: trunk/examples/opengl/2dpainting/glwidget.cpp
===================================================================
--- trunk/examples/opengl/2dpainting/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/2dpainting/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/2dpainting/glwidget.h
===================================================================
--- trunk/examples/opengl/2dpainting/glwidget.h	(revision 561)
+++ trunk/examples/opengl/2dpainting/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/2dpainting/helper.cpp
===================================================================
--- trunk/examples/opengl/2dpainting/helper.cpp	(revision 561)
+++ trunk/examples/opengl/2dpainting/helper.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/2dpainting/helper.h
===================================================================
--- trunk/examples/opengl/2dpainting/helper.h	(revision 561)
+++ trunk/examples/opengl/2dpainting/helper.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/2dpainting/main.cpp
===================================================================
--- trunk/examples/opengl/2dpainting/main.cpp	(revision 561)
+++ trunk/examples/opengl/2dpainting/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/2dpainting/widget.cpp
===================================================================
--- trunk/examples/opengl/2dpainting/widget.cpp	(revision 561)
+++ trunk/examples/opengl/2dpainting/widget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/2dpainting/widget.h
===================================================================
--- trunk/examples/opengl/2dpainting/widget.h	(revision 561)
+++ trunk/examples/opengl/2dpainting/widget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/2dpainting/window.cpp
===================================================================
--- trunk/examples/opengl/2dpainting/window.cpp	(revision 561)
+++ trunk/examples/opengl/2dpainting/window.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/2dpainting/window.h
===================================================================
--- trunk/examples/opengl/2dpainting/window.h	(revision 561)
+++ trunk/examples/opengl/2dpainting/window.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/framebufferobject/glwidget.cpp
===================================================================
--- trunk/examples/opengl/framebufferobject/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/framebufferobject/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/framebufferobject/glwidget.h
===================================================================
--- trunk/examples/opengl/framebufferobject/glwidget.h	(revision 561)
+++ trunk/examples/opengl/framebufferobject/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/framebufferobject/main.cpp
===================================================================
--- trunk/examples/opengl/framebufferobject/main.cpp	(revision 561)
+++ trunk/examples/opengl/framebufferobject/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/framebufferobject2/glwidget.cpp
===================================================================
--- trunk/examples/opengl/framebufferobject2/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/framebufferobject2/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/framebufferobject2/glwidget.h
===================================================================
--- trunk/examples/opengl/framebufferobject2/glwidget.h	(revision 561)
+++ trunk/examples/opengl/framebufferobject2/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/framebufferobject2/main.cpp
===================================================================
--- trunk/examples/opengl/framebufferobject2/main.cpp	(revision 561)
+++ trunk/examples/opengl/framebufferobject2/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/grabber/glwidget.cpp
===================================================================
--- trunk/examples/opengl/grabber/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/grabber/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/grabber/glwidget.h
===================================================================
--- trunk/examples/opengl/grabber/glwidget.h	(revision 561)
+++ trunk/examples/opengl/grabber/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/grabber/main.cpp
===================================================================
--- trunk/examples/opengl/grabber/main.cpp	(revision 561)
+++ trunk/examples/opengl/grabber/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/grabber/mainwindow.cpp
===================================================================
--- trunk/examples/opengl/grabber/mainwindow.cpp	(revision 561)
+++ trunk/examples/opengl/grabber/mainwindow.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/grabber/mainwindow.h
===================================================================
--- trunk/examples/opengl/grabber/mainwindow.h	(revision 561)
+++ trunk/examples/opengl/grabber/mainwindow.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl/glwidget.cpp
===================================================================
--- trunk/examples/opengl/hellogl/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl/glwidget.h
===================================================================
--- trunk/examples/opengl/hellogl/glwidget.h	(revision 561)
+++ trunk/examples/opengl/hellogl/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl/main.cpp
===================================================================
--- trunk/examples/opengl/hellogl/main.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl/window.cpp
===================================================================
--- trunk/examples/opengl/hellogl/window.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl/window.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl/window.h
===================================================================
--- trunk/examples/opengl/hellogl/window.h	(revision 561)
+++ trunk/examples/opengl/hellogl/window.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es/bubble.cpp
===================================================================
--- trunk/examples/opengl/hellogl_es/bubble.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl_es/bubble.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es/bubble.h
===================================================================
--- trunk/examples/opengl/hellogl_es/bubble.h	(revision 561)
+++ trunk/examples/opengl/hellogl_es/bubble.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es/cl_helper.h
===================================================================
--- trunk/examples/opengl/hellogl_es/cl_helper.h	(revision 561)
+++ trunk/examples/opengl/hellogl_es/cl_helper.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es/glwidget.cpp
===================================================================
--- trunk/examples/opengl/hellogl_es/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl_es/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es/glwidget.h
===================================================================
--- trunk/examples/opengl/hellogl_es/glwidget.h	(revision 561)
+++ trunk/examples/opengl/hellogl_es/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es/main.cpp
===================================================================
--- trunk/examples/opengl/hellogl_es/main.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl_es/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es/mainwindow.cpp
===================================================================
--- trunk/examples/opengl/hellogl_es/mainwindow.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl_es/mainwindow.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es/mainwindow.h
===================================================================
--- trunk/examples/opengl/hellogl_es/mainwindow.h	(revision 561)
+++ trunk/examples/opengl/hellogl_es/mainwindow.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es2/bubble.cpp
===================================================================
--- trunk/examples/opengl/hellogl_es2/bubble.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl_es2/bubble.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es2/bubble.h
===================================================================
--- trunk/examples/opengl/hellogl_es2/bubble.h	(revision 561)
+++ trunk/examples/opengl/hellogl_es2/bubble.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es2/glwidget.cpp
===================================================================
--- trunk/examples/opengl/hellogl_es2/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl_es2/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es2/glwidget.h
===================================================================
--- trunk/examples/opengl/hellogl_es2/glwidget.h	(revision 561)
+++ trunk/examples/opengl/hellogl_es2/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es2/main.cpp
===================================================================
--- trunk/examples/opengl/hellogl_es2/main.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl_es2/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es2/mainwindow.cpp
===================================================================
--- trunk/examples/opengl/hellogl_es2/mainwindow.cpp	(revision 561)
+++ trunk/examples/opengl/hellogl_es2/mainwindow.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/hellogl_es2/mainwindow.h
===================================================================
--- trunk/examples/opengl/hellogl_es2/mainwindow.h	(revision 561)
+++ trunk/examples/opengl/hellogl_es2/mainwindow.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/overpainting/bubble.cpp
===================================================================
--- trunk/examples/opengl/overpainting/bubble.cpp	(revision 561)
+++ trunk/examples/opengl/overpainting/bubble.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/overpainting/bubble.h
===================================================================
--- trunk/examples/opengl/overpainting/bubble.h	(revision 561)
+++ trunk/examples/opengl/overpainting/bubble.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/overpainting/glwidget.cpp
===================================================================
--- trunk/examples/opengl/overpainting/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/overpainting/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/overpainting/glwidget.h
===================================================================
--- trunk/examples/opengl/overpainting/glwidget.h	(revision 561)
+++ trunk/examples/opengl/overpainting/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/overpainting/main.cpp
===================================================================
--- trunk/examples/opengl/overpainting/main.cpp	(revision 561)
+++ trunk/examples/opengl/overpainting/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/pbuffers/cube.cpp
===================================================================
--- trunk/examples/opengl/pbuffers/cube.cpp	(revision 561)
+++ trunk/examples/opengl/pbuffers/cube.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/pbuffers/cube.h
===================================================================
--- trunk/examples/opengl/pbuffers/cube.h	(revision 561)
+++ trunk/examples/opengl/pbuffers/cube.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/pbuffers/glwidget.cpp
===================================================================
--- trunk/examples/opengl/pbuffers/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/pbuffers/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/pbuffers/glwidget.h
===================================================================
--- trunk/examples/opengl/pbuffers/glwidget.h	(revision 561)
+++ trunk/examples/opengl/pbuffers/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/pbuffers/main.cpp
===================================================================
--- trunk/examples/opengl/pbuffers/main.cpp	(revision 561)
+++ trunk/examples/opengl/pbuffers/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/pbuffers2/glwidget.cpp
===================================================================
--- trunk/examples/opengl/pbuffers2/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/pbuffers2/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/pbuffers2/glwidget.h
===================================================================
--- trunk/examples/opengl/pbuffers2/glwidget.h	(revision 561)
+++ trunk/examples/opengl/pbuffers2/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/pbuffers2/main.cpp
===================================================================
--- trunk/examples/opengl/pbuffers2/main.cpp	(revision 561)
+++ trunk/examples/opengl/pbuffers2/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/samplebuffers/glwidget.cpp
===================================================================
--- trunk/examples/opengl/samplebuffers/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/samplebuffers/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/samplebuffers/glwidget.h
===================================================================
--- trunk/examples/opengl/samplebuffers/glwidget.h	(revision 561)
+++ trunk/examples/opengl/samplebuffers/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/samplebuffers/main.cpp
===================================================================
--- trunk/examples/opengl/samplebuffers/main.cpp	(revision 561)
+++ trunk/examples/opengl/samplebuffers/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/shared/qtlogo.cpp
===================================================================
--- trunk/examples/opengl/shared/qtlogo.cpp	(revision 561)
+++ trunk/examples/opengl/shared/qtlogo.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/shared/qtlogo.h
===================================================================
--- trunk/examples/opengl/shared/qtlogo.h	(revision 561)
+++ trunk/examples/opengl/shared/qtlogo.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/textures/glwidget.cpp
===================================================================
--- trunk/examples/opengl/textures/glwidget.cpp	(revision 561)
+++ trunk/examples/opengl/textures/glwidget.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/textures/glwidget.h
===================================================================
--- trunk/examples/opengl/textures/glwidget.h	(revision 561)
+++ trunk/examples/opengl/textures/glwidget.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/textures/main.cpp
===================================================================
--- trunk/examples/opengl/textures/main.cpp	(revision 561)
+++ trunk/examples/opengl/textures/main.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/textures/window.cpp
===================================================================
--- trunk/examples/opengl/textures/window.cpp	(revision 561)
+++ trunk/examples/opengl/textures/window.cpp	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)
Index: trunk/examples/opengl/textures/window.h
===================================================================
--- trunk/examples/opengl/textures/window.h	(revision 561)
+++ trunk/examples/opengl/textures/window.h	(revision 651)
@@ -1,5 +1,5 @@
 /****************************************************************************
 **
-** Copyright (C) 2009 Nokia Corporation and/or its subsidiary(-ies).
+** Copyright (C) 2010 Nokia Corporation and/or its subsidiary(-ies).
 ** All rights reserved.
 ** Contact: Nokia Corporation (qt-info@nokia.com)