Index: /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.c
===================================================================
--- /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.c	(revision 839)
+++ /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.c	(revision 840)
@@ -242,7 +242,7 @@
 }
 
-BOOL xstQuerySysTrayVersion(PULONG pulMajor,    // out: major version number
-                            PULONG pulMinor,    // out: minor version number
-                            PULONG pulRevision) // out: revision number
+BOOL xstQuerySysTrayVersion(PULONG pulMajor,
+                            PULONG pulMinor,
+                            PULONG pulRevision)
 {
     BOOL brc;
@@ -270,10 +270,10 @@
 }
 
-BOOL xstAddSysTrayIcon(HWND hwnd,       // in: window handle associated with the icon
-                       USHORT usId,     // in: icon ID to add
-                       HPOINTER hIcon,  // in: icon handle
-                       PCSZ pcszToolTip,// in: tooltip text
-                       ULONG ulMsgId,   // in: message ID for notifications
-                       ULONG ulFlags)   // in: flags (not currently used, must be 0)
+BOOL xstAddSysTrayIcon(HWND hwnd,
+                       USHORT usId,
+                       HPOINTER hIcon,
+                       PCSZ pcszToolTip,
+                       ULONG ulMsgId,
+                       ULONG ulFlags)
 {
     BOOL    brc;
@@ -388,7 +388,7 @@
 }
 
-BOOL xstReplaceSysTrayIcon(HWND hwnd,        // in: window handle associated with the icon
-                           USHORT usId,      // in: icon ID to change
-                           HPOINTER hIcon)   // in: new icon handle
+BOOL xstReplaceSysTrayIcon(HWND hwnd,
+                           USHORT usId,
+                           HPOINTER hIcon)
 {
     BOOL    brc;
@@ -421,6 +421,6 @@
 }
 
-BOOL xstRemoveSysTrayIcon(HWND hwnd,    // in: window handle associated with the icon
-                          USHORT usId)  // in: icon ID to remove
+BOOL xstRemoveSysTrayIcon(HWND hwnd,
+                          USHORT usId)
 {
     BOOL brc;
@@ -469,7 +469,7 @@
 }
 
-BOOL xstSetSysTrayIconToolTip(HWND hwnd,        // in: window handle associated with the icon
-                              USHORT usId,      // in: icon ID to set the tooltip for
-                              PCSZ pcszToolTip) // in: tooltip text
+BOOL xstSetSysTrayIconToolTip(HWND hwnd,
+                              USHORT usId,
+                              PCSZ pcszToolTip)
 {
     BOOL brc;
Index: /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.h
===================================================================
--- /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.h	(revision 839)
+++ /trunk/src/3rdparty/os2/xsystray/apilib/xsystray.h	(revision 840)
@@ -108,6 +108,8 @@
  */
 
-XSTAPI(BOOL, xstQuerySysTrayVersion)(PULONG pulMajor, PULONG pulMinor,
-                                     PULONG pulRevision);
+XSTAPI(BOOL, xstQuerySysTrayVersion)
+    (PULONG pulMajor,     // out: major version number
+     PULONG pulMinor,     // out: minor version number
+     PULONG pulRevision); // out: revision number
 
 /*
@@ -152,6 +154,11 @@
  */
 
-XSTAPI(BOOL, xstAddSysTrayIcon)(HWND hwnd, USHORT usId, HPOINTER hIcon,
-                                PCSZ pcszToolTip, ULONG ulMsgId, ULONG ulFlags);
+XSTAPI(BOOL, xstAddSysTrayIcon)
+    (HWND hwnd,       // in: window handle associated with the icon
+     USHORT usId,     // in: icon ID to add
+     HPOINTER hIcon,  // in: icon handle
+     PCSZ pcszToolTip,// in: tooltip text
+     ULONG ulMsgId,   // in: message ID for notifications
+     ULONG ulFlags);  // in: flags (not currently used, must be 0)
 
 /*
@@ -164,5 +171,8 @@
  */
 
-XSTAPI(BOOL, xstReplaceSysTrayIcon)(HWND hwnd, USHORT usId, HPOINTER hIcon);
+XSTAPI(BOOL, xstReplaceSysTrayIcon)
+    (HWND hwnd,       // in: window handle associated with the icon
+     USHORT usId,     // in: icon ID to change
+     HPOINTER hIcon); // in: new icon handle
 
 /*
@@ -175,5 +185,7 @@
  */
 
-XSTAPI(BOOL, xstRemoveSysTrayIcon)(HWND hwnd, USHORT usId);
+XSTAPI(BOOL, xstRemoveSysTrayIcon)
+    (HWND hwnd,    // in: window handle associated with the icon
+     USHORT usId); // in: icon ID to remove
 
 /*
@@ -194,5 +206,8 @@
  */
 
-XSTAPI(BOOL, xstSetSysTrayIconToolTip)(HWND hwnd, USHORT usId, PCSZ pcszToolTip);
+XSTAPI(BOOL, xstSetSysTrayIconToolTip)
+    (HWND hwnd,         // in: window handle associated with the icon
+     USHORT usId,       // in: icon ID to set the tooltip for
+     PCSZ pcszToolTip); // in: tooltip text
 
 /*
@@ -203,6 +218,6 @@
 
 XSTAPI(BOOL, xstShowSysTrayIconBalloon)(HWND hwnd, USHORT usId, PCSZ pcszTitle,
-                                      PCSZ pcszText, ULONG ulFlags,
-                                      ULONG ulTimeout);
+                                        PCSZ pcszText, ULONG ulFlags,
+                                        ULONG ulTimeout);
 
 /*
@@ -223,5 +238,8 @@
  */
 
-XSTAPI(BOOL, xstQuerySysTrayIconRect)(HWND hwnd, USHORT usId, PRECTL prclRect);
+XSTAPI(BOOL, xstQuerySysTrayIconRect)
+    (HWND hwnd,        // in: window handle associated with the icon
+     USHORT usId,      // in: icon ID to query the rectangle for
+     PRECTL prclRect); // out: where to store the returned rectangle
 
 /*